<?php
namespace Neuron\Person\Controller;

class Type extends \Neuron\Person\Controller {

	public function listAction() {
		$storage = \Neuron\Person\Type\Storage::factory($this->getDb(), $this->getConfig());
		$cpar = new \Neuron\Person\Type($storage);


		$post = $this->getPostParams();

		$arr = $cpar->listType($post['start'], $post['length'], 
			array(	'field'		=> $post['field'], 
					'value'		=>$post['search']['value'], 
					'order' 	=> array(
						'columnName' 	=> $post['columns'][$post['order'][0]['column']]['data'],
						'dir' 			=> $post['order'][0]['dir']
					)
			)
		);
		$params = array();
		if ($arr['data']) {
			foreach ($arr['data'] as $data) {
					array_push($params, $data);
			}
		}
		$result = array('draw'=>$post['draw'],
			'recordsFiltered'=>intval($arr['total']),
			'recordsTotal'=>intval($arr['total']),
			'data'=>$params
		);

		echo json_encode($result);
		return $this->getResponse();
	}
	public function saveAction(){
		$sessmgt = $this->getSession()->get();
		$post 		= $this->getREST()->getParameters();
		$type 		= new \Neuron\Person\Type(
			\Neuron\Person\Type\Storage::factory(
				$this->getDb(),
				$this->getConfig()
			)
		);
		
		$result 	= $type->saveEx($post);
		$result->info = $this->translate($result->info);

		// Clear cache
		$generic 	= new \Neuron\Person\Generic;
		$generic->clearCache(md5(\Neuron\Person\Type::CACHE_HASH));

		return $this->getREST()->getResponse($result);
	}
	
	public function deleteAction(){
		$sessmgt = $this->getSession()->get();
		$post= $this->getPostParams();
		$storage = \Neuron\Person\Type\Storage::factory($this->getDb(), $this->getConfig());
		$ctype = new \Neuron\Person\Type($storage);
		$delete = $ctype->remove($post['type_id']);

		// Clear cache
		$generic 	= new \Neuron\Person\Generic;
		$generic->clearCache(md5(\Neuron\Person\Type::CACHE_HASH));
		
		echo json_encode($delete);
		return $this->getResponse();

	}
}